<%@taglib uri="/WEB-INF/tags.tld" prefix="itrust"%>
<%@page errorPage="/auth/exceptionHandler.jsp"%>

<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.Date"%>
<%@page import="java.text.DateFormat"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="java.sql.Timestamp"%>
<%@page import="edu.ncsu.csc.itrust.exception.FormValidationException"%>
<%@page import="edu.ncsu.csc.itrust.enums.TransactionType"%>
<%@page import="edu.ncsu.csc.itrust.dao.DAOFactory"%>
<%@page import="edu.ncsu.csc.itrust.beans.TransactionBean"%>
<%@page import="edu.ncsu.csc.itrust.beans.TransactionWithRoleBean"%>
<%@page import="org.apache.commons.lang.StringEscapeUtils"%>
<%@page import="edu.ncsu.csc.itrust.enums.TransactionType"%>
<%@page import="edu.ncsu.csc.itrust.enums.Role"%>

<%@include file="/global.jsp" %>

<%
pageTitle = "iTrust - View Transaction Logs";
String view = request.getParameter("viewSelect");
%>

<%@include file="/header.jsp" %>
<%
	//get form data
    String startDate = request.getParameter("startDate");
    String endDate = request.getParameter("endDate");
	String mainRole = request.getParameter("mainRole");
	String secondRole = request.getParameter("secondRole");
    String transactionType = request.getParameter("transactionType");
	String convertedDate = request.getParameter("convertedDate");
	SimpleDateFormat df = new SimpleDateFormat("MM/dd/yyyy");
	String formatted = df.format(new Date());

    if (startDate == null)
    	startDate = "01/01/2000";
    if (endDate == null)
    	endDate = formatted;
%>
<br />
<form action="viewTransactionLogs.jsp" method="post" id="formMain">
<input type="hidden" name="viewSelect" />
<table class="fTable" align="center" id="transactionLogsTable">
	<tr>
		<th colspan="4">View Transaction Logs</th>
	</tr>
    	<tr class="subHeader">
		<td>Start Date:</td>
		<td>
			<input name="startDate" value="<%= StringEscapeUtils.escapeHtml("" + (startDate)) %>" size="10">
            <input type=button value="Select Date" onclick="displayDatePicker('startDate');">
		</td>
		<td>End Date:</td>
		<td>
			<input name="endDate" value="<%= StringEscapeUtils.escapeHtml("" + (endDate)) %>" size="10">
            <input type=button value="Select Date" onclick="displayDatePicker('endDate');">
		</td>
	</tr>
	<tr class="subHeader">
		<td>Main Role:</td>
		<td>
			<select name="mainRole" style="font-size:10" >
				<option value="All"> All</option>
				<%
				for(Role type : Role.values()){
					%><option value="<%= StringEscapeUtils.escapeHtml("" + (type.getUserRolesString()))%>"><%=type.getUserRolesString()%></option><%   
				}
				%>
			</select>
		</td>
		<td>Secondary Role:</td>
		<td>
			<select name="secondRole" style="font-size:10" >
				<option value="All"> All</option>
				<%
				for(Role type : Role.values()){
					%><option value="<%= StringEscapeUtils.escapeHtml("" + (type.getUserRolesString()))%>"><%=type.getUserRolesString()%></option><%   
				}
				%>
				<option value="N/A"> N/A</option>
			</select>
		</td>    
	</tr>
	<tr class="subHeader">
		<td colspan="2" style="text-align: left;">Transaction Type:</td>
		<td>
			<select name="transactionType" style="font-size:10" >
				<option value="All"> All</option>
				<%
				for(TransactionType type : TransactionType.values()){
					%><option value="<%= StringEscapeUtils.escapeHtml("" + (type.name()))%>"><%=type.name()%>
					</option><%   
				}
				%>
			</select>
		</td>
		<td></td>
	</tr>
	<tr>
		<td colspan="1" style="text-align: center;"><input type="submit" id="viewReport" value="View Report" onclick="viewSelect='showList'"></td>
		<td colspan="1" style="text-align: center;"><input type="submit" id="viewGraph" value="Summarize"></td>
		<td> </td>
		<td colspan="1" style="text-align: center;"><button><a href="viewTransactionLogs.jsp?reset=true" style="text-decoration:none; padding: 0.4em;color:black;">Reset</a></button></td>

	</tr>
</table>
</form>
<br />
<%

String resetCheck = null;
if(request.getParameter("reset")!= null){
	resetCheck = request.getParameter("reset");
}

if (view != null && resetCheck != "true") { %>
	<table border=1 align="center">	
		<%
		List<TransactionWithRoleBean> list = DAOFactory.getProductionInstance().getTransactionDAO().getAllTransactionsWithRoles();
		SimpleDateFormat sdf = new SimpleDateFormat("MM/dd/yyyy");
		Date convertedSimpleDate = null;
		Date startSimpleDate = null;
		Date endSimpleDate = null;
		
		if(startDate != ""){
			startSimpleDate = sdf.parse(startDate);
		}
		else{
			startSimpleDate = sdf.parse("01/01/2000");
		}
		if(endDate != ""){
			endSimpleDate = sdf.parse(endDate);
		}
		else{
			endSimpleDate = sdf.parse(formatted);
		}

		boolean dateFormatError = false;
		String regex = "^(1[0-2]|0[1-9])/(3[01]|[12][0-9]|0[1-9])/[0-9]{4}$";
		boolean result = (startDate.matches(regex)||startDate.equals("")) && (endDate.matches(regex)||endDate.equals(""));
		if(!result) {
			dateFormatError = true;
			%>
			<span class="iTrustError">ERROR: Date must by in the format: MM/dd/yyyy</span>
			<%
		} 
		else if(endSimpleDate.before(startSimpleDate)){
			dateFormatError = true;
			%>
			<span class="iTrustError">ERROR: End Date cannot be before Start Date</span>
			<%
		}

		int countEntries = 0;
		if(!dateFormatError){
			%>
				<tr>
					<th>Main Role</th>
					<th>Secondary Role</th>
					<th>Type</th>
					<th>Extra Info</th>
					<th>Time Logged</th>
				</tr>
			<%
			for (TransactionWithRoleBean t : list) {
				
				convertedSimpleDate = sdf.parse(StringEscapeUtils.escapeHtml("" + (t.getConvertedDate())));

				if(StringEscapeUtils.escapeHtml("" + (t.getMainRole())).equals(StringEscapeUtils.escapeHtml(mainRole))
												|| StringEscapeUtils.escapeHtml(mainRole).equals("All")){
					if(StringEscapeUtils.escapeHtml("" + (t.getSecondaryRole())).equals(StringEscapeUtils.escapeHtml(secondRole))
													|| StringEscapeUtils.escapeHtml(secondRole).equals("All")){
						if(StringEscapeUtils.escapeHtml("" + (t.getTransactionType().name())).equals(StringEscapeUtils.escapeHtml	(transactionType)) || StringEscapeUtils.escapeHtml(transactionType).equals("All")){
							if((convertedSimpleDate.before(endSimpleDate) || convertedSimpleDate.equals(endSimpleDate)) && (convertedSimpleDate.after(startSimpleDate) || convertedSimpleDate.equals(startSimpleDate))){
								countEntries++;
								%>
								<tr id="resultRow">
									<td id="mainTD"><%= StringEscapeUtils.escapeHtml("" + (t.getMainRole())) %></td>
									<td id="secondTD"><%= StringEscapeUtils.escapeHtml("" + (t.getSecondaryRole())) %></td>
									<td id="typeTD"><%= StringEscapeUtils.escapeHtml("" + (t.getTransactionType().name())) %></td>
									<td id="infoTD"><%= StringEscapeUtils.escapeHtml("" + (t.getAddedInfo())) %></td>
									<td id="timeTD"><%= StringEscapeUtils.escapeHtml("" + (t.getTimeLogged())) %></td>
								</tr>
								<%
							}
						}
					}
				}
			}

			if(countEntries == 0){
			%>
				<tr id="resultRow">
					<td style="color:red;" id="noResults" colspan="5">There are no results for the criteria specified</td>
				</tr>
			<%
			}
		}
		%>
	</table>

<% } %>
<br />

<%@include file="/footer.jsp" %>